#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QFile>
#include <QMessageBox>
#include <QXmlStreamReader>
#include <QList>
#include <QTime>

#include <zlib.h>

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT


signals :


public slots :
    void slot_pushButtonFileSelect_Clicked();
    void slot_loadFile();
    
public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

    void ProcessFont(QString fileName);

    QXmlStreamReader extended_xml_meta_data;

    #define SWAP_2(x) ( (((x) & 0xff) << 8) | ((unsigned short)(x) >> 8) )
    #define SWAP_4(x) ( ((x) << 24) | \
             (((x) << 8) & 0x00ff0000) | \
             (((x) >> 8) & 0x0000ff00) | \
             ((x) >> 24) )
    #define FIX_SHORT(x) (*(unsigned short *)&(x) = SWAP_2(*(unsigned short *)&(x)))
    #define FIX_INT(x)   (*(unsigned int *)&(x)   = SWAP_4(*(unsigned int *)&(x)))
    #define FIX_FLOAT(x) FIX_INT(x)

    struct woff_tableEntry {
        quint32	tag;            // 4-byte sfnt table identifier.
        quint32	offset;         // Offset to the data, from beginning of WOFF file.
        quint32	compLength;     // Length of the compressed data, excluding padding.
        quint32	origLength;     // Length of the uncompressed table, excluding padding.
        quint32	origChecksum;   // Checksum of the uncompressed table.

        char * tagPretty = new char[5];

        Bytef * data;
    };

    //QList<woff_tableEntry> WOFFEntries;


    struct NameEntry {
        quint16 platformID;
        quint16 platformSpecificID;
        quint16 languageID;
        quint16 nameID;
        quint16 length;
        quint16 offset;
        char * name;
    };

   QList<NameEntry> NameEntries;
    
private:
    Ui::MainWindow *ui;

    // Benchmark
    QTime startTime;
    QTime endTime;
};

#endif // MAINWINDOW_H
